                              PCOPY

     Pcopy was made to produce large amounts of different copies, and in
     the process not to lose content.  Pcopy shows the actual situation,
     conveniently arranged, and is able to verify the written data.
     The produced copy is not exact.  The "last altered date and time"
     as well the "volume creation date and time" are changed to the present
     date and time.  Also if the BMFLAG is -1, it is changed to +1, otherwise
     it remains unchanged.  These changes are identical to the changes made
     by the Amiga diskcopy program.  Although pcopy displays a lot of
     information, it is a rather dangerous copier and its purpose lies
     in the production area.


                              START

     Pcopy can be executed from either the CLI or the Workbench.
     Two trackdisk-drives must be available.  That is, ie., the
     internal and a normal external drive.  Selection is done by
     clicking on/off gadgets in a window.  When ready, one can proceed
     by clicking "DONE".  If more than two (or less than two!) drives
     are selected then clicking done has no effect.   Pcopy will
     check for disk presence and identity. (Selected drives may not be
     the same, perhaps done by assign).  If the selected drives are
     available DOS is switched off.
     Pcopy takes control of the drives (as does diskcopy) and sets up the
     user interface. 


                             WINDOWS

     There are two small windows (marked "Now in DFx:") which show, at
     any moment, the drive's contents.  An empty window means an empty
     drive.  Normally the diskname appears in these windows.  If the
     disk cannot produce a name, a classification is displayed.  All
     text different from [VolumeName] is printed in another color.

     In the window "Copy history" appear all names of successfully
     copied disks.

     There is a window with a kind of "scale".  Although the
     depthgadgets disappear during the copy, they still exist and
     work.

     Then there is the control panel with the gadgets in it.


                             GADGETS

     Verify  ON/OFF

     The destination disk is read back and compared with the source.
     It can be turned on and off during the the copy process.

     DFx: --> DFy:

     Defines which is source and which is destination drive.  The
     choice is acknowledged by a different color of the destination
     drive.

     Auto Start  ON/OFF

     If this is off, a copy cycle is started by clicking "Start Copy".
     If it is on, then this is started by the INSERTION of the second
     disk.  It is possible to set some additional conditions.

     Start Copy

     To be used to start the copy process manually.  The command is kept
     until it is possible to start the copy process (two disks inserted).
     A second click before the process is started will nullify the start
     command.


                           AUTO START

     Non DOS     ON/OFF
     Unreadable  ON/OFF

     These two gadgets control the auto-start conditions. 

     These two gadgets admit four possible states, however, only three
     logical states exist.  Implemention of the fourth was beyond my
     "implementationwillingness".

     The logical states are:

     1) Start anyhow.
     2) Destination may not be an Amiga-DOS disk.
     3) Destination must be unreadable.

     1)  Start always.  If the disk is not write protected, it is simply
     overwritten.  This is a dangerous selection and is emphasized by
     an exclamation mark.  If an Amiga-DOS disk is to be overwritten,
     the display beeps and a two second delay will elapse before the copy
     process starts.  Unless you want to get rid of a lot of old disks, I
     STRONGLY suggest you do NOT use this selection.  You'd better use the
     manual start (I know). 
     The switches are:  Non DOS OFF, Unreadable  OFF.

     2)  Destination may not be an Amiga-DOS disk.  During the search
     for the volumename, there was no indication found, which might
     lead to the assumption that the destination disk could be an
     Amiga-DOS disk. (oef!) By other systems, already formatted disks
     are overwritten.  The switches:  Non DOS ON, Unreadable OFF.

     3)  Destination must be unreadable.  The copy process will be
     started only if no data is detected.  For owners of different
     machines, this is not foolproof.  MS-DOS, MSX, Archimedes
     and Atari formats will be seen as readable, but Alas!, Mac is not.
     I did not have more formats available during testing.  I see
     this as the normal selection.  For distribution you normally use
     new disks.  Switches:  Non DOS (don't care), Unreadable ON.


                            REQUESTERS

     If the process is interrupted, a requester will appear.  If abort
     is chosen, then the copy process will be terminated.  The actions
     following upon retry are listed below:

       Source read error # xx
       On cylinder # yy
     Retry tries to read again.

       Destination write error # xx
       On cylinder # yy
     Retry tries to write again.

       Destination read error # xx  (Verify)
       On cylinder # yy
     Retry writes again.

       Destination verify error on cyl # yy
     Retry rewrites the cylinder.

     Pcopy refuses to continue after disk removal.  Therefore, it is not
     useful to select retry after a writeprotect detection.

     The error #'s are those from trackdisk.  They are:

     20-27  data error             (retry)
     28     write protected        (abort)
     29     disk change or absent  (abort)
     30     seek error             (retry)
     31     short of memory        (retry, check multitasking)
     32-35  pcopy fault            (abort, quit, reboot?)

     (Details: KRM Libraries and Devices, page 271)


                           CLASSIFICATION

     Unreadable:  During the read of sector 0, there was no sector
     header found.  

     Non DOS:  During the read of sector 0, a sector header was found,
     but the sector was unreadable or it was not an Amiga-DOS sector.
     ("DOS\0" or "KICK").

     Near DOS:  The format and data of sector 0 was Amiga-DOS, but
     this was all.


                           PERFORMANCE

     Pcopy is as fast as diskcopy, at least if verify is off.  To copy
     a cylinder the disk must make 7 revolutions.  If verify is on, 4
     more are needed.  Times are 1.33 minutes without verify and 2.27
     minutes with verify.  Perhaps this can be reduced to 5/7
     revolutions and 1.06/1.33 minutes.  Maybe for some later revision
     with its own device driver.  At the moment, pcopy is clean.  I mean
     no tricks, just proper systemcalls.


                          VERIFY POLICY

     The absence of verify with diskcopy was also a stimulus to make
     pcopy.  If you use it to make a backup of your labour disk,
     verify is not important.  If an error occurs, the chance it is
     precisely on an important spot is small.  And there are a lot of
     possibilities to salve a disk.

     This is different with a PD disk.  If you have a PD disk with an
     error, then it is difficult or impossible to repair.  So be
     attentive to what you copy and pass on of PDS.  Someone four
     copies away, can have great difficulties, because content that he
     has could be defective, and the defects have a snow-balling effect.
     So please use verify.

     An example:
     I have all Fish disks and the CRC program on F133 discovered +/-
     300 errors in my library.  So the route to me was rough (and
     without verify).

     I like to receive mail, so if you have any suggestions or
     remarks:

     Dirk Reisig
     Woudweeren 10
     1151 AV  Broek in Waterland
     Netherland  (or Holland)

